variable "prefix" {
  type    = string
  default = "vm-"
}

variable "pool_path" {
  type    = string
  default = "/var/lib/libvirt/"
}

variable "image" {
  type = object({
    name = string
    url  = string
    format = string
  })
}

variable "vm" {
  type = object({
    cpu    = number
    ram    = number
    disk   = number
    bridge = string
  })
}

variable "domains" {
  description = "List of VMs with specified parameters"
  type = list(object({
    name = string,
    cpu  = number,
    ram  = number,
    disk = number,
    ip   = string
  }))
}